//////////////////////////////////////////////
//			DEMOD01.C					//
//		2007/08/23	by	CCS.C				//
//////////////////////////////////////////////
#include	<16f876.h>

////////			n[hEGA̒`
#FUSES  HS,NOWDT,NOPROTECT,PUT,BROWNOUT,NOLVP
#use delay (CLOCK=10000000)		//NbN10MHz
#use	RS232(BAUD=1200,XMIT=PIN_C6,RCV=PIN_C7)
#byte	PA=5					// portA
#byte	PB=6					// portB
#byte	PC=7					// portC

/////////			}N
#define	DB		PB			//LCD Data
#define	RS		PIN_B4		//LCD RS Pin
#define	E		PIN_B5		//LCD E Pin
#define	ETX		0x0d		//Iʒmp
#define RXMAX	20			//Mő啶

////////			ϐ`
char	rxd[RXMAX + 2];		// Mobt@
int		rxp;				// M|C^
short	int	RXEND;			// MtO

////////			tCu[̃CN[h
#include <lcdlib4l.c>

/////////			bot̏
void	init(void){
	setup_adc_ports(NO_ANALOGS);		//A/D̐ݒ
	set_tris_a(0);						//|[g`o͐ݒ
	set_tris_b(0);						//|[gao͐ݒ
	PB = 0;								//|[gaNA
	set_tris_c(0x80);					//RC7 input
	enable_interrupts(INT_RDA);			//M荞݉
	enable_interrupts(GLOBAL);			//S荞݉
	lcd_init();							//LCD
}

////////			C֐
void	main(void){
	int i,j;
	const int lcd_addr[4] = {0x80, 0x88, 0xc0, 0xc8};
	
	init();								// CPU
	lcd_clear();
	RXEND = 0;
	for (i = 0; i < RXMAX; i++) rxd[i] = ' ';	//Mobt@NA
	rxp = 0;
	while(1){
		while(!RXEND);					//M҂
		for (i = 0; i < 4; i++){
			lcd_cmd(lcd_addr[i]);		//\ʒu
			for (j = 0; j < 4; j++){
				lcd_data(rxd[rxp]);
				rxp++;
			}
		}
		RXEND = 0;
		for (i = 0; i < RXMAX; i++) rxd[i] = ' ';	//Mobt@NA
		rxp = 0;
	}
}

/////////	RS232C M荞
#INT_RDA
rda_isr(){
	char	c;

	c = getc();
	if (c == ETX){
		rxp = 0;
		RXEND = 1;
		return;
	}
	if(!RXEND){
		rxd[rxp]=c;					//MWX^̓eobt@ɓǂݎ
		rxp++;						//|C^i߂		
		if(rxp >= RXMAX) rxp=0;		//őM
	}
}
